using System.IO;
using System;
using Avalonia.Controls;
using Avalonia.Interactivity;
using Avalonia.Media;
using System.Collections.Generic;
using static System.Runtime.InteropServices.JavaScript.JSType;
using System.Linq;

namespace inter
{

    // 
    public struct User
    {
        public string surname; // 
        public string name; // 
        public string patronomic; // 
        public string gender; // 
        public string phone; // 
        public DateTime birthday; //  
        public string dayOfWeek;
        public string signZodiac;
    }

    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void WriteFile(object sender, RoutedEventArgs e)
        {
            User user = new User();

            //   
            user.surname = tbSurname.Text;
            user.name = tbName.Text;
            user.patronomic = tbPatronomic.Text;
            user.phone = tbPhone.Text;

            //    ,   ,    
            if (rbM.IsChecked == true) user.gender = "";
            if (rbW.IsChecked == true) user.gender = "";

            user.birthday = new DateTime(Convert.ToInt32(tbYear.Text), cbMonth.SelectedIndex, Convert.ToInt32(tbDay.Text));

            user.dayOfWeek = Convert.ToString(user.birthday.DayOfWeek);

            if (user.birthday.Day >= 24 && user.birthday.Month == 12 || user.birthday.Day <= 30 && user.birthday.Month == 1)
            {
                user.signZodiac = "";
            }
            else if (user.birthday.Day == 31 && user.birthday.Month == 1 || user.birthday.Day <= 29 && user.birthday.Month == 2)
            {
                user.signZodiac = "";
            }
            else if (user.birthday.Month == 3)
            {
                user.signZodiac = "";
            }
            else if (user.birthday.Month == 4)
            {
                user.signZodiac = "";
            }
            else if (user.birthday.Day <= 14 && user.birthday.Month == 5)
            {
                user.signZodiac = "";
            }
            else if (user.birthday.Day >= 14 && user.birthday.Month == 5 || user.birthday.Day <= 2 && user.birthday.Month == 6)
            {
                user.signZodiac = "";
            }
            else if (user.birthday.Day >= 2 && user.birthday.Day <= 12 && user.birthday.Month == 6 )
            {
                user.signZodiac = "";
            }
            else if (user.birthday.Day != 24 && user.birthday.Day >= 13 && user.birthday.Month == 6 || user.birthday.Day <= 6 && user.birthday.Month == 7)
            {
                user.signZodiac = "";
            }
            else if (user.birthday.Day == 24 && user.birthday.Month == 6)
            {
                user.signZodiac = " ";
            }
            else if (user.birthday.Day >= 7 && user.birthday.Month == 7)
            {
                user.signZodiac = "";
            }
            else if (user.birthday.Day >= 1 && user.birthday.Day <= 28 && user.birthday.Month == 8)
            {
                user.signZodiac = "";
            }
            else if (user.birthday.Day >= 29 && user.birthday.Month == 8 || user.birthday.Day <= 13 && user.birthday.Month == 9)
            {
                user.signZodiac = "";
            }
            else if (user.birthday.Day >= 14 && user.birthday.Day <= 27 && user.birthday.Month == 9)
            {
                user.signZodiac = "";
            }
            else if (user.birthday.Day >= 28 && user.birthday.Month == 8 || user.birthday.Day <= 15 && user.birthday.Month == 10)
            {
                user.signZodiac = "";
            }
            else if (user.birthday.Day >= 16 && user.birthday.Month == 10 || user.birthday.Day <= 8 && user.birthday.Month == 11)
            {
                user.signZodiac = "";
            }
            else if (user.birthday.Day >= 9 && user.birthday.Day <= 28 && user.birthday.Month == 11)
            {
                user.signZodiac = "";
            }
            else if (user.birthday.Day >= 29 &&  user.birthday.Month == 11 || user.birthday.Day <= 23 && user.birthday.Month == 12)
            {
                user.signZodiac = "";
            }
            else
            {

            }

            //   
            using (StreamWriter sw = new StreamWriter("users.csv", true, System.Text.Encoding.UTF8))
            {
                sw.WriteLine(user.surname + ";" + user.name + ";" + user.patronomic + ";" + user.gender + ";" + user.phone + ";" + user.birthday + ";" + user.dayOfWeek + ";" + user.signZodiac);
                ShowMessage.Text = " ";
            }
        }

        public SolidColorBrush color(string continent)
        {
            switch (continent)
            {
                case "":
                    return new SolidColorBrush(Color.FromArgb(50, 255, 0, 0));
                case "":
                    return new SolidColorBrush(Color.FromArgb(50, 0, 0, 255));
                default:
                    return new SolidColorBrush(Color.FromRgb(0, 0, 0));
            }
        }

        List<User> L = new List<User>();
        private void ShowUserClick(object sender, RoutedEventArgs e)
        {

            ShowUser.IsVisible = true;
            WritePanel.IsVisible = false;

            using (StreamReader sr = new StreamReader("users.csv"))
            {
                string line = "";
                while (!sr.EndOfStream)
                {
                    line = sr.ReadLine();
                    string[] lineArray = line.Split(';');
                    L.Add(new User()
                    {
                        surname = lineArray[0],
                        name = lineArray[1],
                        patronomic = lineArray[2],
                        gender = lineArray[3],
                        phone = lineArray[4],
                        birthday = Convert.ToDateTime(lineArray[5]),
                        dayOfWeek = lineArray[6],
                        signZodiac = lineArray[7],
                    });
                }
                List<User> L1 = L.OrderBy(x => x.surname).ThenBy(y => y.name).ToList();
                foreach (User u in L1)
                {
                    TextBlock tbFIO = new TextBlock()
                    {
                        Text = ": " + u.surname + " " + u.name + " " + u.patronomic,
                    };
                    TextBlock tbPhone = new TextBlock()
                    {
                        Text = ": " + u.phone
                    };
                    TextBlock tbGender = new TextBlock()
                    {
                        Text = ": " + u.gender
                    };
                    TextBlock tbDate = new TextBlock()
                    {
                        Text = " : " + u.birthday
                    };
                    TextBlock tbWeek = new TextBlock()
                    {
                        Text = " : " + u.dayOfWeek
                    };
                    TextBlock tbZodiak = new TextBlock()
                    {
                        Text = " : " + u.signZodiac
                    };

                    StackPanel spUser = new StackPanel();
                    spUser.HorizontalAlignment = Avalonia.Layout.HorizontalAlignment.Center;
                    spUser.Children.Add(tbFIO);
                    spUser.Children.Add(tbPhone);
                    spUser.Children.Add(tbGender);
                    spUser.Children.Add(tbDate);
                    spUser.Children.Add(tbWeek);
                    spUser.Children.Add(tbZodiak);


                    Border border = new Border();
                    border.Background = color(u.gender);
                    border.BorderBrush = Brushes.Indigo;
                    border.BorderThickness = new Avalonia.Thickness(2);
                    border.CornerRadius = new Avalonia.CornerRadius(50);
                    border.Margin = new Avalonia.Thickness(10);
                    border.Padding = new Avalonia.Thickness(20);

                    border.Child = spUser;

                    ShowUser.Children.Add(border);
                }
            }
        }
        private void Back_Click(object sender, RoutedEventArgs e)
        {
            ShowUser.IsVisible = false;
            WritePanel.IsVisible = true;
        }
    }
}